# Django адміністратор

Щоб додавати, редагувати і видаляти пости, які ми щойно змоделювали, використаємо Django адміністратор.

Відкриймо файл `blog/admin.py` і замінимо його зміст на наступні рядки:

    from django.contrib import admin
    from .models import Post
    
    admin.site.register(Post)
    

Як можна побачити, ми імпортуємо (включаємо) модель посту Post визначену у попередньому розділі. Щоб зробити нашу модель видимою на сторінці адміністратора, потрібно зареєструвати модель за допомогою `admin.site.register(Post)`.

OK, переглянути нашу модель Post. Не забудьте запустити `python manage.py runserver` в консолі щоб запустити веб сервер. Перейдіть до браузера і наберіть адресу: http://127.0.0.1:8000/admin/ Ви побачите сторінку входу наступного зразку:

![Сторінка авторизації](images/login_page2.png)

Для того, щоб здійснити вхід потрібно створити суперюзера *superuser* - користувача, котрий контролює сайт. Перейдіть назад до командного рядка і наберіть `python manage.py createsuperuser`, натисніть enter і наберіть ваше ім'я користувача (маленькі літери, без пробілів), email адресу і пароль. Вихідний результат має виглядати наступним чином (де ім'я користувача і email повинні містити ваші дані):

    (myvenv) ~/djangogirls$ python manage.py createsuperuser
    Username: admin
    Email address: admin@admin.com
    Password:
    Password (again):
    Superuser created successfully.
    

Поверніться до вашого браузера і здійсніть вхід використовуючи логін пароль щойно створеного суперюзера, ви маєте побачити робочу панель Django адміністратора.

![Django адміністратор](images/django_admin3.png)

Перейдіть до постів і трохи поекспериментуйте з ними. Додайте 5-6 блог постів. Не турбуйтесь про їх зміст - можете просто скопіювати і вставити деякий текст з цього навчального посібника в якості поста щоб зберегти час :).

Переконайтесь у тому, що принаймні два або три поста (але не всі) мають встановлену дату публікації. Це стане у нагоді пізніше. 

![Django адміністратор](images/edit_post3.png)

Якщо бажаєте дізнатися про Django адміністратор, зверніться до Django документації: https://docs.djangoproject.com/en/1.8/ref/contrib/admin/

Напевно настав вдалий момент прихопити чашку кави (або чаю) і з'їсти трохи солодощів. Ви створили вашу першу Django модель, то ж заслуговуєте на невеличке задоволення!
